
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* pwm frequency */
static double pwmhz = 1 / ((1 / 4032000.0) * 130);

/* amplitude */
static double scale = 130 / 2;

static unsigned char  dtmf_sintab[128];
static unsigned short dtmf_phase_tab[256]; /* per Hz */

phase_inc(int inorm)
{
	double steps = pwmhz / inorm;
	int inc = 65536 / steps + 0.5;

	dtmf_phase_tab[inorm] = inc;

	printf("\tdtmf_phase_inc_%d\t= %5d # %4.1f steps\n", inorm, inc, steps);
}

static unsigned short ph_inc, ph_acc;
static unsigned char afc = 40; /* AFC center, runtime selected */

tst() /* runtime */
{
	unsigned char n, c;
	unsigned short nn;
	int i;

	ph_acc += ph_inc;
	n = ph_acc >> 8;
	c = n;
	n &= 0x7F;
	n = dtmf_sintab[n];
	nn = n * scale; /* EA=A*B */
	n = nn >> 8;
	if (c & 0x80)
		n = (~n + 1);

	n = afc + n;

	for (i = 0; i < 78; ++i) {
		int c = ' ';
		if (i == afc)
			c = '|';
		if (i == n)
			c = '*';
		putchar(c);
	}
	putchar('\n');
}

visual(int inorm)
{
	int i;

printf("%d Hz\n", inorm);

	ph_inc = dtmf_phase_tab[inorm];
	ph_acc = 0;

	for (i = 0; i < 30; ++i)
		tst();
}

main(int argc, char **argv)
{
	int col = 0;
	int i;

	printf("dtmf_sintab:\n");

	for (i = 0; i < 256; ++i) {
		if (col++ == 0)
			printf("\t.byte ");

		dtmf_sintab[i] = scale * (sin(2 * M_PI * i / 256) + 1.0) / 2 + .5;

		printf("%2d", (signed char) dtmf_sintab[i]);

		printf((col &= 7) ? ", " : "\n");
	}
	printf("!\n! pwm %.5f Hz\n!\n", pwmhz);
	phase_inc(1750);
	phase_inc(1633);
	phase_inc(1477);
	phase_inc(1336);
	phase_inc(1209);
	phase_inc( 941);
	phase_inc( 852);
	phase_inc( 770);
	phase_inc( 697);
}
